var name_map = {'orders':'Most recent orders','sales':'Recent sales', 'inventory':'Low stock products', 'customers':'Top customers', 
  'searches':'Recent searches', 'fb':'Feeds and backups', 'counts':'Store statistics', 'rss':'RSS reader' , 'quickreference':'Active features', 'ad':'Special offers'};


 
$(window).load(function () {
  ajax_load_all();
});

$('#dash_reset').click(function() {
  $('#dash').load("start.cgi", {ajax: "1", dash_reset:"1"}, function() { ajax_load_all(); });
});

function ajax_load_all() {
  for (var i in name_map) {
    var dash_el = $('#dash_' + i);
    
    if (!dash_el.hasClass('hide')) {
      
      ajax_load(dash_el, "ajax=" + i + "&default=1", name_map[i]);
    }
  }
}

function ajax_load(block, data, display_name) {
  block.html("<h2 class=\"dash_loading\">Loading module: " + display_name + "...</h2>");
  var tsTimeStamp= new Date().getTime();
  //alert(block.attr("id"));
  //alert(data);
  block.load("start.cgi", data + "&time=" + tsTimeStamp, function(response) {
    //alert(response);
    if (response.search("ss_signin.cgi") > -1) {
      window.location = "start.cgi";
      return;
    }
    var dash_h = block.find('.dash_h').first();
    dash_h.css({cursor:'move'});
    dash_h.find('.dash_ed_op').click(function() {clickEdit(this);});
    dash_h.find('.dash_remove').click(function() {clickRemove(this);});
    block.find('.dash_ed_cl').click(function() {clickApply(this, display_name);});
    if (data.search("rss") != -1) 
    {
      $('.dash_rss_rem').click(function() {rss_rem(this);});
      $('.dash_rss_add').click(function() {rss_add(this);});
      $('.rss_feed_title').find('img').error(function() { $(this).remove();});
      $('.feed_tab').click(function() {clickRSSTab(this);});
    }
    
    $('.dash_cs').css({cursor: 'pointer', 'text-decoration': 'underline'});
    
    if (data.search("sales") != -1)
    {
      $('#dash_sales_cs_0').click(function() { column_sort("sales", 0);});
      $('#dash_sales_cs_1').click(function() { column_sort("sales", 1);});
      $('#dash_sales_cs_2').click(function() { column_sort("sales", 2);});
    }
    
    if (data.search("customers") != -1)
    {
      $('#dash_customers_cs_0').click(function() { column_sort("customers", 0);});
      $('#dash_customers_cs_1').click(function() { column_sort("customers", 1);});
      $('#dash_customers_cs_2').click(function() { column_sort("customers", 2);});
    }
    
  });
}

function clickRemove (el) {
  var t = $(el).parent().parent();
  t.css({display:'none'});
  $.post("start.cgi", { ajax: "1", dash_off: t.attr('id') });
}

function clickEdit (el) {
  var t = $(el).parent().parent().children('.dash_edit');
  if (t.css('display') == 'block') {
    $(el).text("Edit");
    t.css({display:'none'});
  } else {
    $(el).text("Done");
    t.css({display:'block'});
  }
}

function clickApply(el, display_name) {
  var form = $(el).parent();
  var block = form.parent().parent();
  //alert(form.serialize());
  ajax_load(block,form.serialize(), display_name);
}

function clickRSSTab(el) {
  var t = $(el);
  ajax_load($('#dash_rss'), "ajax=rss&default=1&feed_tab=" + t.attr('id'), "RSS reader");
}

function rss_rem(el) {
    $(el).closest('tr').next().remove();
    $(el).closest('tr').remove();
}

function rss_add(el) {
    //var num = (parseInt($(el).prev().attr('name').substr(18)) + 1);
    var prev = $(el).closest('tr').prev();
    var num = (parseInt(prev.find("input").attr('name').substr(17)) + 1);
    if (isNaN(num))
      num = 1;
    var html =  '<tr class=\"feed_location_c\"><td>Feed location:</td><td colspan=2><input type=text size=\"35\" name=\"dash_rss_link_new' + num + '\"></td>';
    html += '<td class=\"feed_use_c\" rowspan=2><a class=\"dash_a dash_rss_rem\" href=#>X</a></td></tr>';
    html += '<tr class=\"feed_name_c\"><td>Feed title:</td><td><input type=text size=\"15\" name=\"dash_rss_name_new' + num + '\"></td>';
    html += '<td class=\"feed_items_c\">Retrieve<input type=text size=\"1\" name=\"dash_rss_items_new' + num + '\" value=\"3\">items</td></tr>';
    prev.after(html);
    prev.next().find('.dash_rss_rem').click(function() {rss_rem(this);});
}

function column_sort(module, column) {
  ajax_load($('#dash_' + module), "ajax=" + module + "&default=1&sort=" + column, name_map[module]);
}


/*
 * Based on script from NETTUTS.com [by James Padolsey]
 */
var dashJS = {
    
    jQuery : $,
    
    settings : {
        columns : '.dash_column',
        handleSelector: '.dash_h'
    },

    init : function () {
        this.makeSortable();
        
    },
    
       
    makeSortable : function () {
        var dashJS = this,
            $ = this.jQuery,
            settings = this.settings;
        

        $(settings.columns).sortable({
            connectWith: $(settings.columns),
            handle: settings.handleSelector,
            revert: 200,
            delay: 100,
            opacity: 0.8,
            containment: 'document',
            items: 'li',
            placeholder: 'placeholder',
            forcePlaceholderSize: true,
            scrollSpeed:10,
            stop: function (e,ui) {
                var cc = $('#dash_column1').sortable('toArray');
                var i = 2;
                while ($('#dash_column'+i).length) {
                  cc = cc + (",|," +  $('#dash_column' + i).sortable('toArray'));
                  i++;
                }
                /*alert(cc);*/
                $.post("start.cgi", { ajax: "1", dash_els: cc });
            }
            

        });
    }
  
};

dashJS.init();